<template>
  <div class="pagination">
    <b-pagination
      :current.sync="currentPage"
      :total="totalItem"
      :range-before="rangeBefore"
      :range-after="rangeAfter"
      :per-page="perPage"
      :icon-prev="prevIcon"
      :icon-next="nextIcon"
      aria-next-label="Next page"
      aria-previous-label="Previous page"
      aria-page-label="Page"
      aria-current-label="Current page"
    >
    </b-pagination>
    <b-field class="perPage" label="per Page" horizontal>
      <b-select v-model="perPage">
        <option value="5">5</option>
        <option value="10" default>10</option>
        <option value="15">15</option>
        <option value="20">20</option>
      </b-select>
    </b-field>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  props: {
    store: {
      type: String,
      required: true,
    },
    collection: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      rangeBefore: 2,
      rangeAfter: 1,
      //   perPage: 10,
      prevIcon: 'chevron-left',
      nextIcon: 'chevron-right',
    }
  },

  computed: {
    ...mapGetters({
      pagination: `product/pagination`,
    }),
    currentPage: {
      get() {
        return this.$store.state[this.store][this.collection].currentPage
      },
      set(value) {
        this.$store.dispatch(`${this.store}/setCurrentPage`, value)
      },
    },
    perPage: {
      get() {
        return this.$store.state[this.store][this.collection].perPage
      },
      set(value) {
        this.$store.dispatch(`${this.store}/setPerPage`, value)
      },
    },
    totalItem: {
      get() {
        return this.$store.state[this.store][this.collection].totalItem
      },
    },
  },
  watch: {
    currentPage(newValue, oldValue) {
      // eslint-disable-next-line no-console
      this.paginatePage(newValue)
    },
    perPage(newValue, oldValue) {
      // eslint-disable-next-line no-console
      this.paginatePerPage(newValue)
    },
  },
  methods: {
    paginatePage(pageNumber) {
      this.$store.dispatch(this.store + '/getList', {
        page: pageNumber,
        perPage: this.perPage,
      })
    },
    paginatePerPage(perPage) {
      this.$store.dispatch(this.store + '/getList', {
        page: 1,
        perPage,
      })
    },
  },
}
</script>

<style>
.pagination {
  font-weight: normal;
  margin-left: auto;
}

.pagination > .perPage {
  margin-left: auto;
}
</style>
